<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>QuorumHierarchical.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.quorum.flexible</a> &gt; <span class="el_source">QuorumHierarchical.java</span></div><h1>QuorumHierarchical.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server.quorum.flexible;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileReader;
import java.io.IOException;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Properties;
import java.util.Map.Entry;


import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import org.apache.zookeeper.server.quorum.QuorumPeerConfig.ConfigException;


/**
 * This class implements a validator for hierarchical quorums. With this
 * construction, zookeeper servers are split into disjoint groups, and 
 * each server has a weight. We obtain a quorum if we get more than half
 * of the total weight of a group for a majority of groups.
 * 
 * The configuration of quorums uses two parameters: group and weight. 
 * Groups are sets of ZooKeeper servers, and we set a group by passing
 * a colon-separated list of server ids. It is also necessary to assign
 * weights to server. Here is an example of a configuration that creates
 * three groups and assigns a weight of 1 to each server:
 * 
 *  group.1=1:2:3
 *  group.2=4:5:6
 *  group.3=7:8:9
 *  
 *  weight.1=1
 *  weight.2=1
 *  weight.3=1
 *  weight.4=1
 *  weight.5=1
 *  weight.6=1
 *  weight.7=1
 *  weight.8=1
 *  weight.9=1
 * 
 * Note that it is still necessary to define peers using the server keyword.
 */

public class QuorumHierarchical implements QuorumVerifier {
<span class="fc" id="L68">    private static final Logger LOG = LoggerFactory.getLogger(QuorumHierarchical.class);</span>

    HashMap&lt;Long, Long&gt; serverWeight;
    HashMap&lt;Long, Long&gt; serverGroup;
    HashMap&lt;Long, Long&gt; groupWeight;
    
    int numGroups;
   
    /**
     * This contructor requires the quorum configuration
     * to be declared in a separate file, and it takes the
     * file as an input parameter.
     */
    public QuorumHierarchical(String filename)
<span class="nc" id="L82">    throws ConfigException {</span>
<span class="nc" id="L83">        this.serverWeight = new HashMap&lt;Long, Long&gt;();</span>
<span class="nc" id="L84">        this.serverGroup = new HashMap&lt;Long, Long&gt;();</span>
<span class="nc" id="L85">        this.groupWeight = new HashMap&lt;Long, Long&gt;();</span>
<span class="nc" id="L86">        this.numGroups = 0;</span>
        
<span class="nc" id="L88">        readConfigFile(filename);</span>
<span class="nc" id="L89">    }</span>
    
    /**
     * This constructor takes a set of properties. We use
     * it in the unit test for this feature.
     */
    
    public QuorumHierarchical(Properties qp)
<span class="fc" id="L97">    throws ConfigException {</span>
<span class="fc" id="L98">        this.serverWeight = new HashMap&lt;Long, Long&gt;();</span>
<span class="fc" id="L99">        this.serverGroup = new HashMap&lt;Long, Long&gt;();</span>
<span class="fc" id="L100">        this.groupWeight = new HashMap&lt;Long, Long&gt;();</span>
<span class="fc" id="L101">        this.numGroups = 0;</span>
        
<span class="fc" id="L103">        parse(qp);</span>
        
<span class="fc" id="L105">        LOG.info(serverWeight.size() + &quot;, &quot; + serverGroup.size() + &quot;, &quot; + groupWeight.size());</span>
<span class="fc" id="L106">    }</span>
    
   /**
    *  This contructor takes the two hash maps needed to enable 
    *  validating quorums. We use it with QuorumPeerConfig. That is,
    *  we declare weights and groups in the server configuration
    *  file along with the other parameters.
    * @param numGroups
    * @param serverWeight
    * @param serverGroup
    */
    public QuorumHierarchical(int numGroups,
            HashMap&lt;Long, Long&gt; serverWeight,
            HashMap&lt;Long, Long&gt; serverGroup)
<span class="nc" id="L120">    {</span>
<span class="nc" id="L121">        this.serverWeight = serverWeight;</span>
<span class="nc" id="L122">        this.serverGroup = serverGroup;</span>
<span class="nc" id="L123">        this.groupWeight = new HashMap&lt;Long, Long&gt;();</span>
        
<span class="nc" id="L125">        this.numGroups = numGroups;</span>
<span class="nc" id="L126">        computeGroupWeight();   </span>
<span class="nc" id="L127">    }</span>
    
    
    /**
     * Returns the weight of a server.
     * 
     * @param id
     */
    public long getWeight(long id){
<span class="fc" id="L136">        return serverWeight.get(id);</span>
    }
    
    /**
     * Reads a configration file. Called from the constructor
     * that takes a file as an input.
     */
    private void readConfigFile(String filename)
    throws ConfigException{
<span class="nc" id="L145">        File configFile = new File(filename);</span>

<span class="nc" id="L147">        LOG.info(&quot;Reading configuration from: &quot; + configFile);</span>

        try {
<span class="nc bnc" id="L150" title="All 2 branches missed.">            if (!configFile.exists()) {</span>
<span class="nc" id="L151">                throw new IllegalArgumentException(configFile.toString()</span>
                        + &quot; file is missing&quot;);
            }
    
<span class="nc" id="L155">            Properties cfg = new Properties();</span>
<span class="nc" id="L156">            FileInputStream in = new FileInputStream(configFile);</span>
            try {
<span class="nc" id="L158">                cfg.load(in);</span>
<span class="nc" id="L159">            } finally {</span>
<span class="nc" id="L160">                in.close();</span>
<span class="nc" id="L161">            }</span>
    
<span class="nc" id="L163">            parse(cfg);</span>
<span class="nc" id="L164">        } catch (IOException e) {</span>
<span class="nc" id="L165">            throw new ConfigException(&quot;Error processing &quot; + filename, e);</span>
<span class="nc" id="L166">        } catch (IllegalArgumentException e) {</span>
<span class="nc" id="L167">            throw new ConfigException(&quot;Error processing &quot; + filename, e);</span>
<span class="nc" id="L168">        }</span>
        
<span class="nc" id="L170">    }</span>
    
    
    /**
     * Parse properties if configuration given in a separate file.
     */
    private void parse(Properties quorumProp){
<span class="fc bfc" id="L177" title="All 2 branches covered.">        for (Entry&lt;Object, Object&gt; entry : quorumProp.entrySet()) {</span>
<span class="fc" id="L178">            String key = entry.getKey().toString();</span>
<span class="fc" id="L179">            String value = entry.getValue().toString(); </span>
<span class="fc bfc" id="L180" title="All 2 branches covered.">            if (key.startsWith(&quot;group&quot;)) {</span>
<span class="fc" id="L181">                int dot = key.indexOf('.');</span>
<span class="fc" id="L182">                long gid = Long.parseLong(key.substring(dot + 1));</span>
                
<span class="fc" id="L184">                numGroups++;</span>
                
<span class="fc" id="L186">                String parts[] = value.split(&quot;:&quot;);</span>
<span class="fc bfc" id="L187" title="All 2 branches covered.">                for(String s : parts){</span>
<span class="fc" id="L188">                    long sid = Long.parseLong(s);</span>
<span class="fc" id="L189">                    serverGroup.put(sid, gid);</span>
                }
                    
                
<span class="pc bpc" id="L193" title="1 of 2 branches missed.">            } else if(key.startsWith(&quot;weight&quot;)) {</span>
<span class="fc" id="L194">                int dot = key.indexOf('.');</span>
<span class="fc" id="L195">                long sid = Long.parseLong(key.substring(dot + 1));</span>
<span class="fc" id="L196">                serverWeight.put(sid, Long.parseLong(value));</span>
            }
<span class="fc" id="L198">        }</span>
        
<span class="fc" id="L200">        computeGroupWeight();</span>
<span class="fc" id="L201">    }</span>
    
    /**
     * This method pre-computes the weights of groups to speed up processing
     * when validating a given set. We compute the weights of groups in 
     * different places, so we have a separate method.
     */
    private void computeGroupWeight(){
<span class="fc bfc" id="L209" title="All 2 branches covered.">        for(long sid : serverGroup.keySet()){</span>
<span class="fc" id="L210">            Long gid = serverGroup.get(sid);</span>
<span class="fc bfc" id="L211" title="All 2 branches covered.">            if(!groupWeight.containsKey(gid))</span>
<span class="fc" id="L212">                groupWeight.put(gid, serverWeight.get(sid));</span>
            else {
<span class="fc" id="L214">                long totalWeight = serverWeight.get(sid) + groupWeight.get(gid);</span>
<span class="fc" id="L215">                groupWeight.put(gid, totalWeight);</span>
            } 
<span class="fc" id="L217">        }    </span>
        
        /*
         * Do not consider groups with weight zero
         */
<span class="fc bfc" id="L222" title="All 2 branches covered.">        for(long weight: groupWeight.values()){</span>
<span class="fc" id="L223">            LOG.debug(&quot;Group weight: &quot; + weight);</span>
<span class="fc bfc" id="L224" title="All 2 branches covered.">            if(weight == ((long) 0)){</span>
<span class="fc" id="L225">                numGroups--;</span>
<span class="fc" id="L226">                LOG.debug(&quot;One zero-weight group: &quot; + 1 + &quot;, &quot; + numGroups);</span>
            }
<span class="fc" id="L228">        }</span>
<span class="fc" id="L229">    }</span>
    
    /**
     * Verifies if a given set is a quorum.
     */
    public boolean containsQuorum(HashSet&lt;Long&gt; set){
<span class="fc" id="L235">        HashMap&lt;Long, Long&gt; expansion = new HashMap&lt;Long, Long&gt;();</span>
        
        /*
         * Adds up weights per group
         */
<span class="fc bfc" id="L240" title="All 2 branches covered.">        if(set.size() == 0) return false;</span>
<span class="fc" id="L241">        else LOG.debug(&quot;Set size: &quot; + set.size());</span>
        
<span class="fc bfc" id="L243" title="All 2 branches covered.">        for(long sid : set){</span>
<span class="fc" id="L244">            Long gid = serverGroup.get(sid);</span>
<span class="fc bfc" id="L245" title="All 2 branches covered.">            if(!expansion.containsKey(gid))</span>
<span class="fc" id="L246">                expansion.put(gid, serverWeight.get(sid));</span>
            else {
<span class="fc" id="L248">                long totalWeight = serverWeight.get(sid) + expansion.get(gid);</span>
<span class="fc" id="L249">                expansion.put(gid, totalWeight);</span>
            }
<span class="fc" id="L251">        }</span>
  
        /*
         * Check if all groups have majority
         */
<span class="fc" id="L256">        int majGroupCounter = 0;</span>
<span class="fc bfc" id="L257" title="All 2 branches covered.">        for(long gid : expansion.keySet()) {</span>
<span class="fc" id="L258">            LOG.debug(&quot;Group info: &quot; + expansion.get(gid) + &quot;, &quot; + gid + &quot;, &quot; + groupWeight.get(gid));</span>
<span class="fc bfc" id="L259" title="All 2 branches covered.">            if(expansion.get(gid) &gt; (groupWeight.get(gid) / 2) )</span>
<span class="fc" id="L260">                majGroupCounter++;</span>
<span class="fc" id="L261">        }</span>
        
<span class="fc" id="L263">        LOG.debug(&quot;Majority group counter: &quot; + majGroupCounter + &quot;, &quot; + numGroups); </span>
<span class="fc bfc" id="L264" title="All 2 branches covered.">        if((majGroupCounter &gt; (numGroups / 2))){</span>
<span class="fc" id="L265">            LOG.debug(&quot;Positive set size: &quot; + set.size());</span>
<span class="fc" id="L266">            return true;</span>
        }
        else {
<span class="fc" id="L269">            LOG.debug(&quot;Negative set size: &quot; + set.size());</span>
<span class="fc" id="L270">            return false;</span>
        }
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>